 %    <CustomTools>
%      <Menu>
%       <Submenu name="CUSTOM">
%        <Item name="enhance Local Contrast (CLAHE Method)" icon="Matlab" tooltip="equalize dark and bright regions">
%          <Command>MatlabXT::XT_enhanceLocalContrast(%i)</Command>
%        </Item>
%       </Submenu>
%      </Menu>
%    </CustomTools>

 function XT_enhanceLocalContrast(aImarisApplicationID)
 %aImarisApplicationID=0
 
 javaaddpath ImarisLib.jar;
 vImarisLib = ImarisLib;
 vObjectId = 0; % this might be replaced by "vObjectId = <a name=getobjectid><b>GetObjectId</b></a>" (see later)
 vImarisApplication = vImarisLib.GetApplication(aImarisApplicationID);  %% parameters

  
 %include functions path
info=what;
addpath([info.path,'/functions'])  
 

%% load data
vDataSet = vImarisApplication.GetDataSet;
%% parameters


% input channel
cNames = getImarisChannelNames(vDataSet);
channel = listdlg('PromptString','Select channel to enhance','ListString',cNames,'SelectionMode','single')-1;
%channel = 0

NumTiles = 16;
ClipLimit = 0.06;

% clahe parameters
prompt = {'EnterNumber of Tiles:','Enter ClipLimit:'};
dlg_title = 'CLAHE parameters';
num_lines = 1;
def = {num2str(NumTiles),num2str(ClipLimit)};
answer = inputdlg(prompt,dlg_title,num_lines,def);
NumTiles = str2double(answer{1});
ClipLimit = str2double(answer{2});


%% prepare new channel


channelcolor = vDataSet.GetChannelColorRGBA(channel);

vLastC = vDataSet.GetSizeC;
vNewC = vLastC +1;
vDataSet.SetSizeC(vNewC); %add new channel
vDataSet.SetChannelName(vNewC-1,[cNames{channel+1},' - enhanced contrast'])
vDataSet.SetChannelColorRGBA(vNewC-1,channelcolor);



 

%% apply clahe slice by slice 
 for tstep = 1: vDataSet.GetSizeT()
     for zstep = 1: vDataSet.GetSizeZ() 
        slice =uint8(vDataSet.GetDataSliceBytes(zstep-1,channel,tstep-1));
        sliceeq = (adapthisteq(slice,'NumTiles',[NumTiles NumTiles],'ClipLimit',ClipLimit));
        vDataSet.SetDataSliceBytes(sliceeq,zstep-1,vNewC-1,tstep-1); 
     end
 end
 
 
 
 
 